'------------------------------------------------------------------------
'                         FinTV.vbs (v4.24)
'------------------------------------------------------------------------
' - Run "RunMeInBackground" -function in order to get your data updated.
'   Your antivirus-software may detect this as a malicious script, but
'   that's just because this writes a small temporary (.tmp) file into
'   your system. 
'
'   Samurize will ask you where to save this file.
'
' - Use "Add text file" -meter to view. (*)
'
' - In TextFile Properties write down full path (the one samurize asked)
'   and filename televisio.tmp into "Text File To Read From:" -datafield
'   (tex. c:\program files\samurize\scripts\televisio.tmp) (*)
'
' (*) You can skip these steps if you set NO_TMPFILE = TRUE.
'     No temporary file will be saved.
'
' - You may change user variables below.
'
'
'                     -- Author: Sami Kinnunen --
'
'               samikin @ murobbs -- samikin @ samurize
'
' Fixaukset 4.22 versiosta lhtien Scelt
'------------------------------------------------------------------------

Function RunMeInBackground(polku_johon_haluat_ohjelmatiedoston_tallentuvan)
	dim prg(35)
'------------------------------------------------------------------
'----------------------- User variables ---------------------------
'------------------------------------------------------------------
	const PROGRAMS	 = 2			' Number - Amount of programs per channel
	const NO_PROGRAM = "-"			' "String" - What to display if no program was found
	const SEPARATE	 = " "			' "String" - Put this line between channels ("" means no line between)

	const NO_TMPFILE = TRUE		' TRUE - Output everything into %v-variable
						' FALSE - Output everything into televisio.tmp file

	const LINKABLE	 = FALSE		' FALSE - No link-support
						' TRUE - Allow meter linkage to display additional info about program

	const FORMAT	 = "AIKA OHJELMA"	' "String" - Output format
						' ==>> FORMAT = "AIKA OHJELMA" outputs "16:20 Tv-Uutiset"
						' ==>> FORMAT = "OHJELMA (AIKA)" outputs "Tv-Uutiset (16:20)" etc.

	prg(1)		 = 1			' 1 / 0 - Include / do not include programs from YLE1
	prg(2)		 = 1			' 1 / 0 - Include / do not include programs from YLE2
	prg(3)		 = 1			' 1 / 0 - Include / do not include programs from MTV3
	prg(4)		 = 1			' 1 / 0 - Include / do not include programs from Nelonen
	prg(5)		 = 0			' 1 / 0 - Include / do not include programs from SubTV
	prg(6)		 = 0			' 1 / 0 - Include / do not include programs from CNBC
	prg(7)		 = 0			' 1 / 0 - Include / do not include programs from Eurosport
	prg(8)		 = 0			' 1 / 0 - Include / do not include programs from MTV Nordic
	prg(9)		 = 0			' 1 / 0 - Include / do not include programs from BBC World
	prg(10)		 = 0			' 1 / 0 - Include / do not include programs from SVT Europa
	prg(11)		 = 0			' 1 / 0 - Include / do not include programs from Canal+
	prg(12)		 = 0			' 1 / 0 - Include / do not include programs from Canal+ Kulta
	prg(13)		 = 0			' 1 / 0 - Include / do not include programs from Canal+ Sininen
	prg(14)		 = 0			' 1 / 0 - Include / do not include programs from TV1000
	prg(15)		 = 0			' 1 / 0 - Include / do not include programs from TV1000 Cinema
	prg(16)		 = 0			' 1 / 0 - Include / do not include programs from YLE24
	prg(17)		 = 0			' 1 / 0 - Include / do not include programs from YLE Teema
	prg(18)		 = 0			' 1 / 0 - Include / do not include programs from YLE FST
	prg(19)		 = 0			' 1 / 0 - Include / do not include programs from Urheilukanava
	prg(20)		 = 0			' 1 / 0 - Include / do not include programs from TV Finland
	prg(21)		 = 0			' 1 / 0 - Include / do not include programs from TV Jyvskyl
	prg(22)		 = 0			' 1 / 0 - Include / do not include programs from Turku TV
	prg(23)		 = 0			' 1 / 0 - Include / do not include programs from TV-Tampere
	prg(24)		 = 0			' 1 / 0 - Include / do not include programs from MTV3+
	prg(25)		 = 0			' 1 / 0 - Include / do not include programs from Nelonen Plus
	prg(26)		 = 0			' 1 / 0 - Include / do not include programs from SVT 1
	prg(27)		 = 0			' 1 / 0 - Include / do not include programs from SVT 2
	prg(28)		 = 0			' 1 / 0 - Include / do not include programs from TV3
	prg(29)		 = 0			' 1 / 0 - Include / do not include programs from TV4
	prg(30)		 = 0			' 1 / 0 - Include / do not include programs from Kanal5
	prg(31)		 = 0			' 1 / 0 - Include / do not include programs from Discovery Channel
	prg(32)		 = 0			' 1 / 0 - Include / do not include programs from Animal Planet
	prg(33)		 = 0			' 1 / 0 - Include / do not include programs from SVT24
	prg(34)		 = 0			' 1 / 0 - Include / do not include programs from Suosikkikanava
	prg(35)		 = 0			' 1 / 0 - Include / do not include programs from ZTV

'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'   Default fileformat (when all prg()-values are set to 1):
'   Line1:	YLE1 - Now		Line2:	YLE1 - Next			Line3:	Empty
'   Line4:	YLE2 - Now		Line5:	YLE2 - Next			Line6:	Empty
'   Line7:	MTV3 - Now		Line8:	MTV3 - Next			Line9:	Empty
'   Line10:	Nelonen - Now		Line11:	Nelonen - Next			Line12:	Empty
'   Line13:	SubTV - Now		Line14:	SubTV - Next			Line15:	Empty
'   Line16:	CNBC - Now		Line17:	CNBC - Next			Line18:	Empty
'   Line19:	Eurosport - Now		Line20:	Eurosport - Next		Line21:	Empty
'   Line22:	MTV Nordic - Now	Line23:	MTV Nordic - Next		Line24:	Empty
'   Line25:	BBC World - Now		Line26:	BBC World - Next		Line27:	Empty
'   Line28:	SVT Europa - Now	Line29:	SVT Europa - Next		Line30:	Empty
'   Line31:	Canal+ - Now		Line32:	Canal+ - Next			Line33:	Empty
'   Line34:	Canal+ Kulta - Now	Line35:	Canal+ Kulta - Next		Line36:	Empty
'   Line37:	Canal+ Sininen - Now	Line38:	Canal+ Sininen - Next		Line39:	Empty
'   Line40:	TV1000 - Now		Line41:	TV1000 - Next			Line42:	Empty
'   Line43:	TV1000 Cinema - Now	Line44:	TV1000 Cinema - Next		Line45:	Empty
'   Line46:	YLE24 - Now		Line47: YLE24 - Next			Line48:	Empty
'   Line49:	YLE Teema - Now		Line50:	YLE Teema - Next		Line51:	Empty
'   Line52:	YLE FST - Now		Line53:	YLE FST - Next			Line54:	Empty
'   Line55:	Urheilukanava - now	Line56:	Urheilukanava - Next		Line57:	Empty
'   Line58:	TV Finland - Now	Line59: TV Finland - Next		Line60:	Empty
'   Line61:	TV Jyvskyl - Now	Line62: TV Jyvskyl - Next		Line63:	Empty
'   Line64:	Turku TV - Now		Line65:	Turku TV - Next			Line66:	Empty
'   Line67:	TV-Tampere - Now	Line68:	TV-Tampere - Next		Line69:	Empty
'   Line70:	MTV3+ - Now		Line71:	MTV3+ - Next			Line72:	Empty
'   Line73:	Nelonen Plus - Now	Line74:	Nelonen Plus - Next		Line75:	Empty
'   Line76:	SVT 1 - now		Line77:	SVT 1 - Next			Line78:	Empty
'   Line79:	SVT2 - Now		Line80: SVT 2 - Next			Line81:	Empty
'   Line82:	TV3 - Now		Line83: TV3 - Next			Line84:	Empty
'   Line85:	TV4 - Now		Line86:	TV4 - Next			Line87:	Empty
'   Line88:	Kanal5 - Now		Line89:	Kanal5 - Next			Line90:	Empty
'   Line91:	Discovery Ch. - now	Line92:	Discovery Ch. - Next		Line93:	Empty
'   Line94:	Animal Planet - Now	Line95: Animal Planet - Next		Line96:	Empty
'   Line97:	SVT24 - Now		Line98: SVT24 - Next			Line99:	Empty
'   Line100:	Suosikkikanava - Now	Line101: Suosikkikanava - Next		Line102: Empty
'   Line103:	ZTV - Now		Line104: ZTV - Next			Line105: Empty
'------------------------------------------------------------------------

'------------ DO NOT CHANGE ANYTHING FROM THIS POINT FORWARD ------------

	dim htmlResult,fs,f,outputti,kello,ohjelma,linkki
	dim poloku,temppi,kanavabuffer,searchstring
	dim sivuindex(6)
	sivuindex(0) = 5
	sivuindex(1) = 5
	sivuindex(2) = 5
	sivuindex(3) = 5
	sivuindex(4) = 5
	sivuindex(5) = 5
	sivuindex(6) = 5

	poloku = trim(polku_johon_haluat_ohjelmatiedoston_tallentuvan)
	if right(poloku,1) <> "\" then
		poloku = poloku & "\"
	end if

	outputti = NULL
	index = 1
	sivusubtract = 0

	for sivu = 0 to 6
		if ( sivu=0 AND ( prg(1)=1 OR prg(2)=1 OR prg(3)=1 OR prg(4)=1 OR prg(5)=1 )) OR _
		   ( sivu=1 AND ( prg(6)=1 OR prg(7)=1 OR prg(8)=1 OR prg(9)=1 OR prg(10)=1 )) OR _
		   ( sivu=2 AND ( prg(11)=1 OR prg(12)=1 OR prg(13)=1 OR prg(14)=1 OR prg(15)=1 )) OR _
		   ( sivu=3 AND ( prg(16)=1 OR prg(17)=1 OR prg(18)=1 OR prg(19)=1 OR prg(20)=1 )) OR _
		   ( sivu=4 AND ( prg(21)=1 OR prg(22)=1 OR prg(23)=1 OR prg(24)=1 OR prg(25)=1 )) OR _
		   ( sivu=5 AND ( prg(26)=1 OR prg(27)=1 OR prg(28)=1 OR prg(29)=1 OR prg(30)=1 )) OR _
		   ( sivu=6 AND ( prg(31)=1 OR prg(32)=1 OR prg(33)=1 OR prg(34)=1 OR prg(35)=1 )) then

			htmlResult = ReturnHTML("http://telkku.com/ohjelmatiedot0"&sivu&".shtml")
			if htmlResult <> "Network error" then
				aloitus = instr( htmlResult, "<td width=20% bgcolor=#FFFFFF class=taulu valign=top>")
				if aloitus > 0 then
					lopetus = instr( aloitus, htmlResult, "</tr></table><table cellspacing=0 cellpadding=0 width=100% border=0>")
					if lopetus > aloitus then
						htmlResult = mid(htmlResult, aloitus, lopetus-aloitus )
					end if
				end if
			end if

			for kanava = index to index+sivuindex(sivu)-1
				if prg(kanava)=1 then
					aloitus = 1
					for solu = 1 to kanava-sivusubtract
						aloitus = instr( aloitus, htmlResult, "<td width=20%" )
						if aloitus = 0 then exit for end if
						aloitus = aloitus + 1
					next
					lopetus = aloitus - 1

					kanavabuffer = ""
					if lopetus > 0 then
						do
							aloitus = instr( lopetus, htmlResult, "<table")
							if aloitus > 0 then
								lopetus = instr( aloitus, htmlResult, "</table")
								if lopetus > aloitus then
									kanavabuffer = kanavabuffer & mid( htmlResult, aloitus, lopetus-aloitus )
									aloitus = lopetus
									for solu = 1 to sivuindex(sivu)
										aloitus = instr( aloitus, htmlResult, "<td width=20%" )
										if aloitus = 0 then exit do end if
										aloitus = aloitus + 1
									next
									lopetus = aloitus - 1
								else exit do end if
							else exit do end if
						loop
					end if

					searchstring = "<tr><td bgcolor=#FFE5BB"
					laskuri = PROGRAMS
					lopetus = 1

					do while laskuri > 0
						i = 0
						aloitus = lopetus
						do while i = 0
							aloitus = instr( aloitus, kanavabuffer, searchstring )
							if aloitus > 0 then
								aloitus = aloitus + len(searchstring)
								aloitus = instr( aloitus, kanavabuffer, ">")
								if aloitus > 0 then
									lopetus = instr( aloitus, kanavabuffer, "</" )
									if lopetus > aloitus then
										kello = mid( kanavabuffer, aloitus+1, lopetus-aloitus-1 )
										aloitus = instr( lopetus, kanavabuffer, "javascript:popup('" )
										if aloitus > 0 then
											aloitus = aloitus + 18
											lopetus = instr( aloitus, kanavabuffer, "')" )
											if lopetus > aloitus then
												linkki = "%lwww.telkku.com/" & mid( kanavabuffer, aloitus, lopetus-aloitus )
												aloitus = instr( lopetus, kanavabuffer, ">" )
												if aloitus > 0 then
													lopetus = instr( aloitus, kanavabuffer, "</" )
													if lopetus > aloitus then
														temppi = trim(replace(mid( kanavabuffer,aloitus+1,lopetus-aloitus-1 ), "<b>", "" ))
														aloitus = instr( temppi, "<" )
														if aloitus > 0 then
															temppi = left( temppi, aloitus-1 )
														end if
														ohjelma = replace( FORMAT, "AIKA", kello )
														ohjelma = replace( ohjelma, "OHJELMA", temppi )
														if LINKABLE = TRUE then
															ohjelma = ohjelma & linkki
														end if
														i = 1
													else i = 2 end if
												else i = 2 end if
											else i = 2 end if
										else i = 2 end if
									else i = 2 end if
								else i = 2 end if
							else i = 2 end if
						loop
						if i = 2 then ohjelma = NO_PROGRAM end if
						outputti = outputti & ohjelma & VBCrLf
						searchstring = "<tr><td valign"
						laskuri = laskuri - 1
					loop
					if SEPARATE <> "" then outputti = outputti & SEPARATE & VBCrLf end if
				end if
			next
		end if
		index = index + sivuindex(sivu)
		sivusubtract = sivusubtract + sivuindex(sivu)
	next

	outputti = replace( outputti, "&nbsp;", "" )
	outputti = replace( outputti, "<br>", "" )
	outputti = replace( outputti, "&#229;", "" )
	outputti = replace( outputti, "&#228;", "" )
	outputti = replace( outputti, "&#246;", "" )
	outputti = replace( outputti, "&#233;", "" )
	outputti = replace( outputti, "&amp;", "&" )

	if NO_TMPFILE = FALSE then
		set fs=CreateObject("Scripting.FileSystemObject")
		if NOT fs.FolderExists(poloku) then
			RunMeInBackground = "Invalid path " & poloku
		else
			set f=fs.CreateTextFile(poloku&"televisio.tmp",true)
			f.write(outputti)
			f.close
			set f=nothing
		end if
		set fs=nothing
		if htmlResult = "Network error" then RunMeInBackground = htmlResult end if
	else
		RunMeInBackground = replace( outputti, VBCrLf, "%b" )
	end if
End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
	On Error Resume Next
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	if err = 0 then
		HTML = objXMLHTTP.responseBody
		Set objRS = CreateObject("ADODB.Recordset")
		objRS.Fields.Append "txt", 200, 35000, &H00000080
		objRS.Open
		objRS.AddNew
		objRS.Fields("txt").AppendChunk HTML
		ReturnHTML = objRS("txt").Value
		objRS.Close
		Set objRS = Nothing
	else
		ReturnHTML = "Network error"
	end if
	On Error GoTo 0
	Set objXMLHTTP = Nothing
End Function
